diff --git a/books/bookvol10.2.pamphlet b/books/bookvol10.2.pamphlet
index 083d50f..0088bcc 100644
--- a/books/bookvol10.2.pamphlet
+++ b/books/bookvol10.2.pamphlet
@@ -4822,6 +4822,9 @@ FileCategory(Name, S): Category == FCdefinition where
           ++ write!(f,s) puts the value s into the file f. 
           ++ The state of f is modified so subsequents call to \spad{write!}
           ++ will append one after another.
+
+        flush: % -> Void
+          ++ flush(f) makes sure that buffered data is written out
  
 @
 <<FILECAT.dotabb>>=
diff --git a/books/bookvol10.3.pamphlet b/books/bookvol10.3.pamphlet
index a46e99a..e5d858b 100644
--- a/books/bookvol10.3.pamphlet
+++ b/books/bookvol10.3.pamphlet
@@ -1,4 +1,4 @@
-\documentclass[dvipdfm]{book}
+documentclass[dvipdfm]{book}
 \usepackage{hyperref}%% we need hyperlinks
 \usepackage{amssymb} %% we need \therefore symbol
 \usepackage{axiom}   %% we need noweb support
@@ -29356,6 +29356,7 @@ o )show File
 \begin{tabular}{lllll}
 \cross{FILE}{close!} &
 \cross{FILE}{coerce} &
+\cross{FILE}{flush} &
 \cross{FILE}{hash} &
 \cross{FILE}{iomode} &
 \cross{FILE}{latex} \\
@@ -29450,6 +29451,10 @@ File(S:SetCategory): FileCategory(FileName, S) with
             TERPRI(f.fileState)$Lisp
             x
 
+        flush f ==
+            f.fileIOmode ^= "output" => error "File not in write state"
+            FORCE_-OUTPUT(f.fileState)$Lisp
+
 @
 <<FILE.dotabb>>=
 "FILE" [color="#88FF44",href="bookvol10.3.pdf#nameddest=FILE"]
diff --git a/changelog b/changelog
index ea0458c..2c7da8d 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,6 @@
+20091126 tpd src/axiom-website/patches.html 20091126.01.tpd.patch
+20091126 tpd bookvol10.3 add flush to File domain
+20091126 tpd bookvol10.2 add flush to FileCategory category
 20091125 tpd src/axiom-website/patches.html 20091125.11.tpd.patch
 20091125 tpd src/clef/edible.c call graph for edible
 20091125 tpd src/axiom-website/patches.html 20091125.10.tpd.patch
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index 4f159f6..a9dd7ee 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -2294,5 +2294,7 @@ books/bookvol8 add call graph for viewalone <br/>
 src/etc/asq.c add call graph for asq <br/>
 <a href="patches/20091125.11.tpd.patch">20091125.11.tpd.patch</a>
 src/clef/edible.c add call graph for edible <br/>
+<a href="patches/20091126.01.tpd.patch">20091126.01.tpd.patch</a>
+books/bookvol10.2, 10.3 add flush operation <br/>
  </body>
 </html>
